#include "Parsodus/backendmanager.h"
#include "Parsodus/backend.h"

namespace pds {
    void BackendManager::registerBackend(std::unique_ptr<Backend> backend) {
        m_backends.push_back(std::move(backend));
    }
    
    Backend* BackendManager::findBackend(std::string lang, std::string parserType) {
        for(std::unique_ptr<Backend> &backend: m_backends) {
            if(backend->canProcessLang(lang) && backend->canGenerateParser(parserType)) return backend.get();
        }
        return nullptr;
    }
}
